/*
 * generated by Xtext 2.10.0
 */
package com.infoly.eclipse.xtext.algo.validation

import com.infoly.eclipse.xtext.algo.algorithmic.Algorithmic
import com.infoly.eclipse.xtext.algo.algorithmic.AlgorithmicPackage
import com.infoly.eclipse.xtext.algo.algorithmic.ConstName
import com.infoly.eclipse.xtext.algo.algorithmic.Expression
import com.infoly.eclipse.xtext.algo.algorithmic.ModuleName
import com.infoly.eclipse.xtext.algo.algorithmic.VarName
import java.util.ArrayList
import org.eclipse.xtext.validation.Check
import com.infoly.eclipse.xtext.algo.algorithmic.TypeName

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
class AlgorithmicValidator extends AbstractAlgorithmicValidator {
	
//	public static val TYPE_NAME =  "com.infoly.eclise.xtext.algo.validation.TypeStartUpperCase&EndsWith_t"
	public static val MODULE_NAME =  "com.infoly.eclise.xtext.algo.validation.ModuleStartLowerCase"
	public static val CONSTANTE_NAME =  "com.infoly.eclise.xtext.algo.validation.ConstInUpperCase"
	public static val VARIABLE_NAME =  "com.infoly.eclise.xtext.algo.validation.VarStartLowerCase"
	
	public static val TYPE_MSG =  "L'identificateur d'un Type commence par une majuscule et se termine par\"_t'\""
	public static val MODULE_MSG =  "L'identificateur d'un module commence par une minuscule"
	public static val CONSTANTE_MSG =  "L'identificateur d'une constante doit tre en capital!"
	public static val VARIABLE_MSG =  "L'identificateur d'une variable commence par une minuscule"	

	public static val DUPLICATE_VARIABLE = "com.infoly.eclise.xtext.algo.DuplicateElement"
	public static val INCOMPATIBLE_TYPES = "com.infoly.eclise.xtext.algo.IncompatibleTypes"

	private	var static varNameList = new ArrayList<VarName> // La liste des variables est la mme pour toutes


//	@Check
//	def checkGreetingStartsWithCapital(Greeting greeting) {
//		if (!Character.isUpperCase(greeting.name.charAt(0))) {
//			warning('Name should start with a capital', 
//					AlgorithmicPackage.Literals.GREETING__NAME,
//					INVALID_NAME)
//		}
//	}

	@Check
	def checkTypeNameStartsWithUpperCaseEndsWith_t(TypeName typeName) {
		if (!Character.isUpperCase(typeName.name.charAt(0)) || !typeName.name.endsWith("_t")) 
//			warning( TYPE_MSG, 	AlgorithmicPackage.Literals.TYPE_NAME__NAME, TYPE_NAME)					
			warning( TYPE_MSG, 	AlgorithmicPackage.Literals.TYPE_NAME__NAME)					
	}

	@Check
	def checkModuleNameStartsWithLowerCase(ModuleName moduleName) {
		if (!Character.isLowerCase(moduleName.name.charAt(0))) 
//			warning( MODULE_MSG, AlgorithmicPackage.Literals.MODULE__NAME, MODULE_NAME)					
			warning( MODULE_MSG, AlgorithmicPackage.Literals.MODULE__NAME)					
	}


	@Check
	def checkConstanteCapital(ConstName constName) {
		val CONSTNAME = constName.name.toUpperCase
		if (constName.name != CONSTNAME) 
//			warning( CONSTANTE_MSG, AlgorithmicPackage.Literals.CONSTS_DECL__NAME, CONSTANTE_NAME)
			warning( CONSTANTE_MSG,  AlgorithmicPackage.Literals.CONSTS_DECL__NAME)
	}

	@Check
	def checkVarNameStartsWithLowerCase(VarName varName) {
		if (!Character.isLowerCase(varName.name.charAt(0))) 
			warning(VARIABLE_MSG, AlgorithmicPackage.Literals.VARS_DECL__NAME,	VARIABLE_NAME)					
	}


 	// Create Variable list
 	@Check
	def void checkVariableList(Algorithmic algo) {
		// Remise  zro de la liste des variables  chaque balayage de l'algorihtme 
		if ( varNameList.size != 0 ) varNameList.clear
		// Construction de la liste des variables  
		val varDecls = algo.globalVars.variables   
		for ( v : varDecls.vars )			// Les diffrents types de variable 
				for ( w : v.name )  		// Les variables d'un mme type
					varNameList.add(w)		
	}
	
 	// Check for duplicates variables
	@Check
	def void checkNoDuplicateVariable(VarName varName) {
		// Balayage de la liste pour y trouver toutes les instances de varName
		for ( vn : varNameList ) {
			if ( vn != varName && vn.name == varName.name ) 
				error("Duplicate variable '" + varName.name + "'", 
	 				AlgorithmicPackage::eINSTANCE.varsDecl_Name, 
	 				DUPLICATE_VARIABLE ) 
		}
	}
	
	@Check
	def void checkTypeConformance(Expression exp) {
/* 		val actualType = exp.inferredType
		val expectedType = exp.expectedType
		
		if (expectedType !== null && !actualType.isAssignableTo(expectedType)) {
			error("expected " +
					expectedType.representation + ", but was " +
					actualType.representation,
					exp.eContainer,
					exp.eContainingFeature,
					WRONG_TYPE)
		}
*/	
	}
	
	
/*		
	@Check
	def void checkStatementAssignment( StatementAssignment statement) {
		var s = statement
		s = statement
		var typeLeft = statement.left.refVar.refData //.class
		var typeRight = statement.right.class
//		statement.left.value == statement.right.	
	}
*/
/*	
	@Check
	def void checkCompatibleTypes(Expression exp) {
		val actualType = exp.typeFor
		val expectedType = exp.expectedType
		if (expectedType == null || actualType == null)
			return; // nothing to check
		if (!actualType.isConformant(expectedType)) {
			error("Incompatible types. Expected '" + expectedType?.name
					+ "' but was '" + actualType?.name + "'", null,
					INCOMPATIBLE_TYPES);
		}
 
 	}
*/	

}
